﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinGrid_MinuteFormatter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            var dt = DummyDataCreator.GetData(10, new Type[] { typeof(int) });
            dt.TableName = "Data";
            dt.Columns["Int32 1"].ColumnName = "Minutes";

            foreach (DataRow row in dt.Rows)
                row["Minutes"] = DummyDataCreator.RandomInt(1, 1000);

            dt.AcceptChanges();
            this.ultraGrid1.DataSource = dt;

            this.ultraGrid1.DisplayLayout.PerformAutoResizeColumns(false, PerformAutoSizeType.AllRowsInBand, AutoResizeColumnWidthOptions.All);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var ov = layout.Override;
            var band = layout.Bands[0];

            var minutesColumn = band.Columns["Minutes"];
            minutesColumn.Format = "hh:mm";
            minutesColumn.FormatInfo = new MinuteFormatter();

            var minutesSummarySettings = band.Summaries.Add(SummaryType.Sum, minutesColumn);
            minutesSummarySettings.DisplayFormat = "{0:hh:mm}";
            minutesSummarySettings.DisplayFormatProvider = new MinuteFormatter();
        }
    }
}
