﻿using System;

namespace WinGrid_MinuteFormatter
{
    internal class MinuteFormatter : IFormatProvider
    {
        private CustomMinuteFormatter customMinuteFormatter = new CustomMinuteFormatter();
        object IFormatProvider.GetFormat(Type formatType)
        {
            if (formatType.IsAssignableFrom(typeof(ICustomFormatter)))
                return customMinuteFormatter;

            return null;
        }

        internal class CustomMinuteFormatter : ICustomFormatter
        {
            string ICustomFormatter.Format(string format, object arg, IFormatProvider formatProvider)
            {
                switch (format)
                {
                    case "hh:mm":
                        int totalMinutes;
                        if (arg is int)
                        {
                            totalMinutes = (int)arg;
                        }
                        else
                        {
                            bool success = int.TryParse(arg.ToString(), out totalMinutes);
                            if (!success)
                                return arg.ToString();
                        }

                        int hours = totalMinutes / 60;
                        int minutes = totalMinutes % 60;

                        return string.Format("{0}:{1}", hours.ToString(), minutes.ToString());                        
                }

                return arg.ToString();
            }
        }
    }

    
}